package service.student.studentaddressservice.controller;

import org.apache.coyote.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import service.student.studentaddressservice.exception.ResourceNotFoundException;
import service.student.studentaddressservice.model.StudentAddress;
import service.student.studentaddressservice.service.StudentAddressService;

import java.util.List;

@CrossOrigin(origins = "*")
@RestController
@RequestMapping("/api/v1")
public class StudentAddressController {

    @Autowired
    StudentAddressService studentAddressService;

    @GetMapping("/studentaddress")
    public List<StudentAddress> getAllStudentAddress() {
        List<StudentAddress> studentAddresses = studentAddressService.getAllStudentAddress();
        return studentAddresses;
    }

    @GetMapping("/studentaddress/{email}")
    public ResponseEntity<StudentAddress> getStudentAddress(@PathVariable("email") String email) throws
            ResourceNotFoundException {
        StudentAddress studentAddress =
                studentAddressService.getStudentAddressByEmail(email).orElseThrow(() -> new ResourceNotFoundException("Email not found: " + email));
        return ResponseEntity.ok(studentAddress);
    }

    @PostMapping("/studentaddress")
    public StudentAddress createStudentAddress(@RequestBody StudentAddress studentAddress){
        return studentAddressService.createStudentAddress(studentAddress);
    }

    @PutMapping("/studentaddress/{email}")
    public ResponseEntity<StudentAddress> updateStudentAddress(@PathVariable("email") String email, @RequestBody StudentAddress studentAddress )
            throws ResourceNotFoundException{
        StudentAddress updatedStudentAddress = studentAddressService.updateStudentAddress(studentAddress, email);
        return ResponseEntity.ok(updatedStudentAddress);
    }
}
